OpenJPH: ojph::local::param_siz Struct Reference

OpenJPH Open-source implementation of JPEG2000 Part-15

Loading...
Searching...
No Matches
ojph::local::param_siz Struct Reference

`#include <ojph_params_local.h>`

## Public Types
enum | : ui16 { RSIZ_NLT_FLAG = 0x200 , RSIZ_HT_FLAG = 0x4000 , RSIZ_EXT_FLAG = 0x8000 }

## Public Member Functions
| param_siz ()
| ~param_siz ()
void | init ()
void | destroy ()
void | set_num_components (ui32 num_comps)
void | set_comp_info (ui32 comp_num, const point &downsampling, ui32 bit_depth, bool is_signed)
void | set_image_extent (point dims)
point | get_image_extent () const
void | set_tile_size (size s)
size | get_tile_size () const
void | set_image_offset (point offset)
point | get_image_offset () const
void | set_tile_offset (point offset)
point | get_tile_offset () const
void | set_cod (const param_cod &cod)
void | check_validity ()
ui16 | get_num_components () const
ui32 | get_bit_depth (ui32 comp_num) const
bool | is_signed (ui32 comp_num) const
point | get_downsampling (ui32 comp_num) const
bool | write (outfile_base *file)
void | read (infile_base *file)
void | link (const param_cod *cod)
void | link (const param_dfs *dfs)
void | set_skipped_resolutions (ui32 skipped_resolutions)
ui32 | get_width (ui32 comp_num) const
ui32 | get_height (ui32 comp_num) const
point | get_recon_downsampling (ui32 comp_num) const
point | get_recon_size (ui32 comp_num) const
ui32 | get_recon_width (ui32 comp_num) const
ui32 | get_recon_height (ui32 comp_num) const
bool | is_ws_kern_support_needed ()
bool | is_dfs_support_needed ()
void | set_Rsiz_flag (ui16 flag)
void | reset_Rsiz_flag (ui16 flag)

## Private Member Functions
| param_siz (const param_siz &)=delete
param_siz & | operator= (const param_siz &)=delete

## Private Attributes
ui16 | Lsiz
ui16 | Rsiz
ui32 | Xsiz
ui32 | Ysiz
ui32 | XOsiz
ui32 | YOsiz
ui32 | XTsiz
ui32 | YTsiz
ui32 | XTOsiz
ui32 | YTOsiz
ui16 | Csiz
siz_comp_info * | cptr
ui32 | skipped_resolutions
int | old_Csiz
siz_comp_info | store [4]
bool | ws_kern_support_needed
bool | dfs_support_needed
const param_cod * | cod
const param_dfs * | dfs

## Detailed Description

Definition at line 165 of file ojph_params_local.h.

## Member Enumeration Documentation

## ◆ anonymous enum

anonymous enum : ui16

Enumerator
RSIZ_NLT_FLAG |
RSIZ_HT_FLAG |
RSIZ_EXT_FLAG |

Definition at line 170 of file ojph_params_local.h.

## Constructor & Destructor Documentation

## ◆ param_siz() [1/2]

ojph::local::param_siz::param_siz | ( |  | ) |
| inline

Definition at line 177 of file ojph_params_local.h.

References init().

Referenced by operator=(), and param_siz().

## ◆ ~param_siz()

ojph::local::param_siz::~param_siz | ( |  | ) |
| inline

Definition at line 178 of file ojph_params_local.h.

References destroy().

## ◆ param_siz() [2/2]

ojph::local::param_siz::param_siz | ( | const param_siz & |  | ) |
| privatedelete

References param_siz().

## Member Function Documentation

## ◆ check_validity()

void ojph::local::param_siz::check_validity | ( |  | ) |
| inline

Definition at line 235 of file ojph_params_local.h.

References OJPH_ERROR, XOsiz, Xsiz, XTOsiz, XTsiz, YOsiz, Ysiz, YTOsiz, and YTsiz.

Referenced by read().

## ◆ destroy()

void ojph::local::param_siz::destroy | ( |  | ) |
| inline

Definition at line 194 of file ojph_params_local.h.

References cptr, and store.

Referenced by ~param_siz().

## ◆ get_bit_depth()

ui32 ojph::local::param_siz::get_bit_depth | ( | ui32 | comp_num | ) | const
| inline

Definition at line 252 of file ojph_params_local.h.

References cptr, and Csiz.

Referenced by ojph::local::param_cod::check_validity(), ojph::local::param_nlt::check_validity(), ojph::local::param_qcd::check_validity(), and ojph::local::tile::finalize_alloc().

## ◆ get_downsampling()

point ojph::local::param_siz::get_downsampling | ( | ui32 | comp_num | ) | const
| inline

Definition at line 262 of file ojph_params_local.h.

References cptr, and Csiz.

Referenced by ojph::local::param_cod::check_validity(), ojph::local::tile::finalize_alloc(), ojph::local::tile_comp::finalize_alloc(), and ojph::local::tile::pre_alloc().

## ◆ get_height()

ui32 ojph::local::param_siz::get_height | ( | ui32 | comp_num | ) | const
| inline

Definition at line 288 of file ojph_params_local.h.

References cptr, get_num_components(), ojph_div_ceil, YOsiz, and Ysiz.

## ◆ get_image_extent()

point ojph::local::param_siz::get_image_extent | ( |  | ) | const
| inline

Definition at line 221 of file ojph_params_local.h.

References Xsiz, and Ysiz.

## ◆ get_image_offset()

point ojph::local::param_siz::get_image_offset | ( |  | ) | const
| inline

Definition at line 226 of file ojph_params_local.h.

References XOsiz, and YOsiz.

## ◆ get_num_components()

ui16 ojph::local::param_siz::get_num_components | ( |  | ) | const
| inline

Definition at line 251 of file ojph_params_local.h.

References Csiz.

Referenced by ojph::local::param_cod::check_validity(), ojph::local::param_nlt::check_validity(), ojph::local::param_qcd::check_validity(), ojph::local::tile::finalize_alloc(), get_height(), get_recon_downsampling(), get_recon_size(), get_width(), and ojph::local::tile::pre_alloc().

## ◆ get_recon_downsampling()

point ojph::local::param_siz::get_recon_downsampling | ( | ui32 | comp_num | ) | const

Definition at line 749 of file ojph_params.cpp.

References cod, cptr, dfs, ojph::local::param_cod::get_dfs_index(), get_num_components(), ojph::local::param_dfs::get_res_downsamp(), ojph::local::param_cod::is_dfs_defined(), skipped_resolutions, ojph::point::x, and ojph::point::y.

Referenced by ojph::local::tile::finalize_alloc(), and get_recon_size().

## ◆ get_recon_height()

ui32 ojph::local::param_siz::get_recon_height | ( | ui32 | comp_num | ) | const
| inline

Definition at line 300 of file ojph_params_local.h.

References get_recon_size(), and ojph::point::y.

## ◆ get_recon_size()

point ojph::local::param_siz::get_recon_size | ( | ui32 | comp_num | ) | const

Definition at line 765 of file ojph_params.cpp.

References get_num_components(), get_recon_downsampling(), ojph_div_ceil, ojph::point::x, XOsiz, Xsiz, ojph::point::y, YOsiz, and Ysiz.

Referenced by get_recon_height(), and get_recon_width().

## ◆ get_recon_width()

ui32 ojph::local::param_siz::get_recon_width | ( | ui32 | comp_num | ) | const
| inline

Definition at line 298 of file ojph_params_local.h.

References get_recon_size(), and ojph::point::x.

## ◆ get_tile_offset()

point ojph::local::param_siz::get_tile_offset | ( |  | ) | const
| inline

Definition at line 230 of file ojph_params_local.h.

References XTOsiz, and YTOsiz.

## ◆ get_tile_size()

size ojph::local::param_siz::get_tile_size | ( |  | ) | const
| inline

Definition at line 223 of file ojph_params_local.h.

References XTsiz, and YTsiz.

## ◆ get_width()

ui32 ojph::local::param_siz::get_width | ( | ui32 | comp_num | ) | const
| inline

Definition at line 280 of file ojph_params_local.h.

References cptr, get_num_components(), ojph_div_ceil, XOsiz, and Xsiz.

## ◆ init()

void ojph::local::param_siz::init | ( |  | ) |
| inline

Definition at line 180 of file ojph_params_local.h.

References cod, cptr, Csiz, dfs, dfs_support_needed, Lsiz, old_Csiz, Rsiz, RSIZ_HT_FLAG, skipped_resolutions, store, ws_kern_support_needed, XOsiz, Xsiz, XTOsiz, XTsiz, YOsiz, Ysiz, YTOsiz, and YTsiz.

Referenced by param_siz().

## ◆ is_dfs_support_needed()

bool ojph::local::param_siz::is_dfs_support_needed | ( |  | ) |
| inline

Definition at line 304 of file ojph_params_local.h.

References dfs_support_needed.

## ◆ is_signed()

bool ojph::local::param_siz::is_signed | ( | ui32 | comp_num | ) | const
| inline

Definition at line 257 of file ojph_params_local.h.

References cptr, and Csiz.

Referenced by ojph::local::param_cod::check_validity(), ojph::local::param_nlt::check_validity(), ojph::local::param_qcd::check_validity(), ojph::local::tile::finalize_alloc(), and set_comp_info().

## ◆ is_ws_kern_support_needed()

bool ojph::local::param_siz::is_ws_kern_support_needed | ( |  | ) |
| inline

Definition at line 303 of file ojph_params_local.h.

References ws_kern_support_needed.

## ◆ link() [1/2]

void ojph::local::param_siz::link | ( | const param_cod * | cod | ) |
| inline

Definition at line 271 of file ojph_params_local.h.

References cod.

## ◆ link() [2/2]

void ojph::local::param_siz::link | ( | const param_dfs * | dfs | ) |
| inline

Definition at line 274 of file ojph_params_local.h.

References dfs.

## ◆ operator=()

param_siz & ojph::local::param_siz::operator= | ( | const param_siz & |  | ) |
| privatedelete

References param_siz().

## ◆ read()

void ojph::local::param_siz::read | ( | infile_base * | file | ) |

Definition at line 680 of file ojph_params.cpp.

References check_validity(), cptr, Csiz, dfs_support_needed, Lsiz, OJPH_ERROR, OJPH_WARN, ojph::infile_base::read(), Rsiz, set_image_offset(), set_num_components(), set_tile_offset(), set_tile_size(), ojph::local::swap_byte(), ws_kern_support_needed, Xsiz, and Ysiz.

## ◆ reset_Rsiz_flag()

void ojph::local::param_siz::reset_Rsiz_flag | ( | ui16 | flag | ) |
| inline

Definition at line 308 of file ojph_params_local.h.

References Rsiz.

## ◆ set_cod()

void ojph::local::param_siz::set_cod | ( | const param_cod & | cod | ) |
| inline

Definition at line 233 of file ojph_params_local.h.

References cod.

## ◆ set_comp_info()

void ojph::local::param_siz::set_comp_info | ( | ui32 | comp_num,
|  | const point & | downsampling,
|  | ui32 | bit_depth,
|  | bool | is_signed )
| inline

Definition at line 210 of file ojph_params_local.h.

References cptr, Csiz, is_signed(), ojph::point::x, and ojph::point::y.

## ◆ set_image_extent()

void ojph::local::param_siz::set_image_extent | ( | point | dims | ) |
| inline

Definition at line 220 of file ojph_params_local.h.

References ojph::point::x, Xsiz, ojph::point::y, and Ysiz.

## ◆ set_image_offset()

void ojph::local::param_siz::set_image_offset | ( | point | offset | ) |
| inline

Definition at line 224 of file ojph_params_local.h.

References ojph::point::x, XOsiz, ojph::point::y, and YOsiz.

Referenced by read().

## ◆ set_num_components()

void ojph::local::param_siz::set_num_components | ( | ui32 | num_comps | ) |
| inline

Definition at line 197 of file ojph_params_local.h.

References cptr, Csiz, old_Csiz, and store.

Referenced by read().

## ◆ set_Rsiz_flag()

void ojph::local::param_siz::set_Rsiz_flag | ( | ui16 | flag | ) |
| inline

Definition at line 306 of file ojph_params_local.h.

References Rsiz.

Referenced by ojph::local::param_nlt::check_validity().

## ◆ set_skipped_resolutions()

void ojph::local::param_siz::set_skipped_resolutions | ( | ui32 | skipped_resolutions | ) |
| inline

Definition at line 277 of file ojph_params_local.h.

References skipped_resolutions.

## ◆ set_tile_offset()

void ojph::local::param_siz::set_tile_offset | ( | point | offset | ) |
| inline

Definition at line 228 of file ojph_params_local.h.

References ojph::point::x, XTOsiz, ojph::point::y, and YTOsiz.

Referenced by read().

## ◆ set_tile_size()

void ojph::local::param_siz::set_tile_size | ( | size | s | ) |
| inline

Definition at line 222 of file ojph_params_local.h.

References ojph::size::h, ojph::size::w, XTsiz, and YTsiz.

Referenced by read().

## ◆ write()

bool ojph::local::param_siz::write | ( | outfile_base * | file | ) |

Definition at line 635 of file ojph_params.cpp.

References cptr, Csiz, Lsiz, Rsiz, ojph::local::SIZ, ojph::local::swap_byte(), ojph::outfile_base::write(), XOsiz, Xsiz, XTOsiz, XTsiz, YOsiz, Ysiz, YTOsiz, and YTsiz.

## Member Data Documentation

## ◆ cod

const param_cod* ojph::local::param_siz::cod
| private

Definition at line 331 of file ojph_params_local.h.

Referenced by get_recon_downsampling(), init(), link(), and set_cod().

## ◆ cptr

siz_comp_info* ojph::local::param_siz::cptr
| private

Definition at line 323 of file ojph_params_local.h.

Referenced by destroy(), get_bit_depth(), get_downsampling(), get_height(), get_recon_downsampling(), get_width(), init(), is_signed(), read(), set_comp_info(), set_num_components(), and write().

## ◆ Csiz

ui16 ojph::local::param_siz::Csiz
| private

Definition at line 322 of file ojph_params_local.h.

Referenced by get_bit_depth(), get_downsampling(), get_num_components(), init(), is_signed(), read(), set_comp_info(), set_num_components(), and write().

## ◆ dfs

const param_dfs* ojph::local::param_siz::dfs
| private

Definition at line 332 of file ojph_params_local.h.

Referenced by get_recon_downsampling(), init(), and link().

## ◆ dfs_support_needed

bool ojph::local::param_siz::dfs_support_needed
| private

Definition at line 330 of file ojph_params_local.h.

Referenced by init(), is_dfs_support_needed(), and read().

## ◆ Lsiz

ui16 ojph::local::param_siz::Lsiz
| private

Definition at line 312 of file ojph_params_local.h.

Referenced by init(), read(), and write().

## ◆ old_Csiz

int ojph::local::param_siz::old_Csiz
| private

Definition at line 327 of file ojph_params_local.h.

Referenced by init(), and set_num_components().

## ◆ Rsiz

ui16 ojph::local::param_siz::Rsiz
| private

Definition at line 313 of file ojph_params_local.h.

Referenced by init(), read(), reset_Rsiz_flag(), set_Rsiz_flag(), and write().

## ◆ skipped_resolutions

ui32 ojph::local::param_siz::skipped_resolutions
| private

Definition at line 326 of file ojph_params_local.h.

Referenced by get_recon_downsampling(), init(), and set_skipped_resolutions().

## ◆ store

siz_comp_info ojph::local::param_siz::store[4]
| private

Definition at line 328 of file ojph_params_local.h.

Referenced by destroy(), init(), and set_num_components().

## ◆ ws_kern_support_needed

bool ojph::local::param_siz::ws_kern_support_needed
| private

Definition at line 329 of file ojph_params_local.h.

Referenced by init(), is_ws_kern_support_needed(), and read().

## ◆ XOsiz

ui32 ojph::local::param_siz::XOsiz
| private

Definition at line 316 of file ojph_params_local.h.

Referenced by check_validity(), get_image_offset(), get_recon_size(), get_width(), init(), set_image_offset(), and write().

## ◆ Xsiz

ui32 ojph::local::param_siz::Xsiz
| private

Definition at line 314 of file ojph_params_local.h.

Referenced by check_validity(), get_image_extent(), get_recon_size(), get_width(), init(), read(), set_image_extent(), and write().

## ◆ XTOsiz

ui32 ojph::local::param_siz::XTOsiz
| private

Definition at line 320 of file ojph_params_local.h.

Referenced by check_validity(), get_tile_offset(), init(), set_tile_offset(), and write().

## ◆ XTsiz

ui32 ojph::local::param_siz::XTsiz
| private

Definition at line 318 of file ojph_params_local.h.

Referenced by check_validity(), get_tile_size(), init(), set_tile_size(), and write().

## ◆ YOsiz

ui32 ojph::local::param_siz::YOsiz
| private

Definition at line 317 of file ojph_params_local.h.

Referenced by check_validity(), get_height(), get_image_offset(), get_recon_size(), init(), set_image_offset(), and write().

## ◆ Ysiz

ui32 ojph::local::param_siz::Ysiz
| private

Definition at line 315 of file ojph_params_local.h.

Referenced by check_validity(), get_height(), get_image_extent(), get_recon_size(), init(), read(), set_image_extent(), and write().

## ◆ YTOsiz

ui32 ojph::local::param_siz::YTOsiz
| private

Definition at line 321 of file ojph_params_local.h.

Referenced by check_validity(), get_tile_offset(), init(), set_tile_offset(), and write().

## ◆ YTsiz

ui32 ojph::local::param_siz::YTsiz
| private

Definition at line 319 of file ojph_params_local.h.

Referenced by check_validity(), get_tile_size(), init(), set_tile_size(), and write().

The documentation for this struct was generated from the following files:

- /build/openjph/src/OpenJPH/src/core/codestream/ojph_params_local.h
- /build/openjph/src/OpenJPH/src/core/codestream/ojph_params.cpp